---  amd64/linux32/linux.h.orig
+++  amd64/linux32/linux.h
@@ -34,6 +34,10 @@
 #define	_AMD64_LINUX_LINUX_H_
 
 #include <sys/signal.h> /* for sigval union */
+#include <sys/param.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/sx.h>
 
 #include <amd64/linux32/linux32_syscall.h>
 
@@ -495,6 +499,7 @@
 
 extern int bsd_to_linux_signal[];
 extern int linux_to_bsd_signal[];
+extern struct sysentvec elf_linux_sysvec;
 
 /*
  * Pluggable ioctl handlers
@@ -527,6 +532,11 @@
 #define	LINUX_O_NDELAY		LINUX_O_NONBLOCK
 #define	LINUX_O_SYNC		010000
 #define	LINUX_FASYNC		020000
+#define	LINUX_O_DIRECT		040000	/* direct disk access hint */
+#define	LINUX_O_LARGEFILE	0100000
+#define	LINUX_O_DIRECTORY	0200000	/* must be a directory */
+#define	LINUX_O_NOFOLLOW	0400000	/* don't follow links */
+#define	LINUX_O_NOATIME		01000000
 
 #define	LINUX_F_DUPFD		0
 #define	LINUX_F_GETFD		1
@@ -737,4 +747,99 @@
 	l_short		revents;
 } __packed;
 
+struct l_user_desc {
+	l_uint		entry_number;
+	l_uint		base_addr;
+	l_uint		limit;
+	l_uint		seg_32bit:1;
+	l_uint		contents:2;
+	l_uint		read_exec_only:1;
+	l_uint		limit_in_pages:1;
+	l_uint		seg_not_present:1;
+	l_uint		useable:1;
+};
+
+struct l_desc_struct {
+           unsigned long a,b;
+};
+
+
+#define LINUX_LOWERWORD	0x0000ffff
+
+/* macros which does the same thing as those in linux include/asm-um/ldt-i386.h 
+ * these convert linux user-space descriptor to machine one
+ */
+#define LDT_entry_a(info) \
+        ((((info)->base_addr & LINUX_LOWERWORD) << 16) | ((info)->limit & LINUX_LOWERWORD))
+
+#define ENTRY_B_READ_EXEC_ONLY	9
+#define ENTRY_B_CONTENTS	10
+#define ENTRY_B_SEG_NOT_PRESENT	15
+#define ENTRY_B_BASE_ADDR	16
+#define ENTRY_B_USEABLE		20
+#define ENTRY_B_SEG32BIT	22
+#define ENTRY_B_LIMIT		23
+
+#define LDT_entry_b(info) \
+        (((info)->base_addr & 0xff000000) | \
+        ((info)->limit & 0xf0000) | \
+        ((info)->contents << ENTRY_B_CONTENTS) | \
+        (((info)->seg_not_present == 0) << ENTRY_B_SEG_NOT_PRESENT) | \
+        (((info)->base_addr & 0x00ff0000) >> ENTRY_B_BASE_ADDR) | \
+        (((info)->read_exec_only == 0) << ENTRY_B_READ_EXEC_ONLY) | \
+        ((info)->seg_32bit << ENTRY_B_SEG32BIT) | \
+        ((info)->useable << ENTRY_B_USEABLE) | \
+        ((info)->limit_in_pages << ENTRY_B_LIMIT) | 0x7000)
+
+#define LDT_empty(info) (\
+        (info)->base_addr       == 0    && \
+        (info)->limit           == 0    && \
+        (info)->contents        == 0    && \
+        (info)->seg_not_present == 1    && \
+        (info)->read_exec_only  == 1    && \
+        (info)->seg_32bit       == 0    && \
+        (info)->limit_in_pages  == 0    && \
+        (info)->useable         == 0    )
+
+/* macros for converting segments, they do the same as those in arch/i386/kernel/process.c */
+#define GET_BASE(desc) ( \
+        (((desc)->a >> 16) & LINUX_LOWERWORD) | \
+        (((desc)->b << 16) & 0x00ff0000) | \
+        ( (desc)->b        & 0xff000000)   )
+
+#define GET_LIMIT(desc) ( \
+        ((desc)->a & LINUX_LOWERWORD) | \
+         ((desc)->b & 0xf0000) )
+
+#define GET_32BIT(desc)         (((desc)->b >> ENTRY_B_SEG32BIT) & 1)
+#define GET_CONTENTS(desc)      (((desc)->b >> ENTRY_B_CONTENTS) & 3)
+#define GET_WRITABLE(desc)      (((desc)->b >> ENTRY_B_READ_EXEC_ONLY) & 1)
+#define GET_LIMIT_PAGES(desc)   (((desc)->b >> ENTRY_B_LIMIT) & 1)
+#define GET_PRESENT(desc)       (((desc)->b >> ENTRY_B_SEG_NOT_PRESENT) & 1)
+#define GET_USEABLE(desc)       (((desc)->b >> ENTRY_B_USEABLE) & 1)
+
+#define LINUX_CLOCK_REALTIME            0
+#define LINUX_CLOCK_MONOTONIC           1
+#define LINUX_CLOCK_PROCESS_CPUTIME_ID  2
+#define LINUX_CLOCK_THREAD_CPUTIME_ID   3
+#define LINUX_CLOCK_REALTIME_HR         4
+#define LINUX_CLOCK_MONOTONIC_HR        5
+
+typedef int l_timer_t;
+typedef int l_mqd_t;
+
+#define CLONE_VM        0x100
+#define CLONE_FS        0x200
+#define CLONE_FILES     0x400
+#define CLONE_SIGHAND   0x800
+#define CLONE_PID       0x1000          /* this flag does not exist in linux anymore */
+#define CLONE_PARENT    0x00008000
+#define CLONE_THREAD    0x10000
+#define CLONE_SETTLS    0x80000
+#define CLONE_CHILD_CLEARTID    0x00200000
+#define CLONE_CHILD_SETTID      0x01000000
+#define CLONE_PARENT_SETTID     0x00100000
+
+#define THREADING_FLAGS (CLONE_VM | CLONE_FS | CLONE_FILES | CLONE_SIGHAND)
+
 #endif /* !_AMD64_LINUX_LINUX_H_ */
---  amd64/linux32/linux32_dummy.c.orig
+++  amd64/linux32/linux32_dummy.c
@@ -72,19 +72,13 @@
 DUMMY(epoll_ctl);
 DUMMY(epoll_wait);
 DUMMY(remap_file_pages);
-DUMMY(set_tid_address);
 DUMMY(timer_create);
 DUMMY(timer_settime);
 DUMMY(timer_gettime);
 DUMMY(timer_getoverrun);
 DUMMY(timer_delete);
-DUMMY(clock_settime);
-DUMMY(clock_gettime);
-DUMMY(clock_getres);
-DUMMY(clock_nanosleep);
 DUMMY(statfs64);
 DUMMY(fstatfs64);
-DUMMY(tgkill);
 DUMMY(utimes);
 DUMMY(fadvise64_64);
 DUMMY(mbind);
---  amd64/linux32/linux32_machdep.c.orig
+++  amd64/linux32/linux32_machdep.c
@@ -35,6 +35,7 @@
 #include <sys/kernel.h>
 #include <sys/systm.h>
 #include <sys/imgact.h>
+#include <sys/limits.h>
 #include <sys/lock.h>
 #include <sys/malloc.h>
 #include <sys/mman.h>
@@ -472,12 +473,6 @@
 	return (0);
 }
 
-#define CLONE_VM	0x100
-#define CLONE_FS	0x200
-#define CLONE_FILES	0x400
-#define CLONE_SIGHAND	0x800
-#define CLONE_PID	0x1000
-
 int
 linux_clone(struct thread *td, struct linux_clone_args *args)
 {
@@ -491,14 +486,9 @@
 		printf(ARGS(clone, "flags %x, stack %x"),
 		    (unsigned int)(uintptr_t)args->flags,
 		    (unsigned int)(uintptr_t)args->stack);
-		if (args->flags & CLONE_PID)
-			printf(LMSG("CLONE_PID not yet supported"));
 	}
 #endif
 
-	if (!args->stack)
-		return (EINVAL);
-
 	exit_signal = args->flags & 0x000000ff;
 	if (exit_signal >= LINUX_NSIG)
 		return (EINVAL);
@@ -522,7 +512,11 @@
 	p2->p_sigparent = exit_signal;
 	PROC_UNLOCK(p2);
 	td2 = FIRST_THREAD_IN_PROC(p2);
-	td2->td_frame->tf_rsp = PTROUT(args->stack);
+	/* in a case of stack = NULL we are supposed to COW calling process stack
+	 * this is what normal fork() does so we just keep the tf_rsp arg intact
+	 */
+	if (args->stack)
+   	   	td2->td_frame->tf_rsp = PTROUT(args->stack);
 
 #ifdef DEBUG
 	if (ldebug(clone))
---  amd64/linux32/linux32_sysvec.c.orig
+++  amd64/linux32/linux32_sysvec.c
@@ -993,7 +993,7 @@
 struct sysentvec elf_linux_sysvec = {
 	LINUX_SYS_MAXSYSCALL,
 	linux_sysent,
-	0xff,
+	0,
 	LINUX_SIGTBLSZ,
 	bsd_to_linux_signal,
 	ELAST + 1,
---  amd64/linux32/syscalls.master.orig
+++  amd64/linux32/syscalls.master
@@ -121,7 +121,7 @@
 62	AUE_NULL	STD	{ int linux_ustat(l_dev_t dev, \
 				    struct l_ustat *ubuf); }
 63	AUE_DUP2	NOPROTO	{ int dup2(u_int from, u_int to); }
-64	AUE_GETPPID	NOPROTO	{ int getppid(void); }
+64	AUE_GETPPID	STD	{ int linux_getppid(void); }
 65	AUE_GETPGRP	NOPROTO	{ int getpgrp(void); }
 66	AUE_SETSID	NOPROTO	{ int setsid(void); }
 67	AUE_NULL	STD	{ int linux_sigaction(l_int sig, \
@@ -213,7 +213,9 @@
 118	AUE_FSYNC	NOPROTO	{ int fsync(int fd); }
 119	AUE_SIGRETURN	STD	{ int linux_sigreturn( \
 				    struct l_sigframe *sfp); }
-120	AUE_RFORK	STD	{ int linux_clone(l_int flags, void *stack); }
+; linux uses some strange calling convention here so we have to use the dummy arg
+120	AUE_RFORK	STD	{ int linux_clone(l_int flags, void *stack, \
+				    void *parent_tidptr, int dummy, void * child_tidptr); }
 121	AUE_SYSCTL	NOPROTO	{ int setdomainname(char *name, \
 				    int len); }
 122	AUE_NULL	STD	{ int linux_newuname( \
@@ -382,8 +384,7 @@
 				    uintptr_t arg); }
 222	AUE_NULL	UNIMPL
 223	AUE_NULL	UNIMPL
-224	AUE_NULL	NOPROTO	{ long linux_getpid(void); } gettid \
-					linux_getpid_args void
+224	AUE_NULL	STD	{ long linux_gettid(void); }
 225	AUE_NULL	UNIMPL	linux_readahead
 226	AUE_NULL	STD	{ int linux_setxattr(void); }
 227	AUE_NULL	STD	{ int linux_lsetxattr(void); }
@@ -397,9 +398,10 @@
 235	AUE_NULL	STD	{ int linux_removexattr(void); }
 236	AUE_NULL	STD	{ int linux_lremovexattr(void); }
 237	AUE_NULL	STD	{ int linux_fremovexattr(void); }
-238	AUE_NULL	UNIMPL	linux_tkill
+238	AUE_NULL	STD	{ int linux_tkill(int tid, int sig); }
 239	AUE_SENDFILE	UNIMPL	linux_sendfile64
-240	AUE_NULL	UNIMPL	linux_futex
+240	AUE_NULL	STD	{ int linux_sys_futex(void *uaddr, int op, int val, \
+					struct l_timespec *timeout, void *uaddr2, int val3); }
 241	AUE_NULL	UNIMPL	linux_sched_setaffinity
 242	AUE_NULL	UNIMPL	linux_sched_getaffinity
 243	AUE_NULL	UNIMPL	linux_set_thread_area
@@ -411,26 +413,26 @@
 249	AUE_NULL	UNIMPL	linux_io_cancel
 250	AUE_NULL	STD	{ int linux_fadvise64(void); }
 251	AUE_NULL	UNIMPL
-252	AUE_EXIT	NOPROTO	{ void sys_exit(int rval); } exit_group \
-				    sys_exit_args void
+252	AUE_EXIT	STD	{ int linux_exit_group(int error_code); }
 253	AUE_NULL	STD	{ int linux_lookup_dcookie(void); }
 254	AUE_NULL	STD	{ int linux_epoll_create(void); }
 255	AUE_NULL	STD	{ int linux_epoll_ctl(void); }
 256	AUE_NULL	STD	{ int linux_epoll_wait(void); }
 257	AUE_NULL	STD	{ int linux_remap_file_pages(void); }
-258	AUE_NULL	STD	{ int linux_set_tid_address(void); }
+258	AUE_NULL	STD	{ int linux_set_tid_address(int *tidptr); }
 259	AUE_NULL	STD	{ int linux_timer_create(void); }
 260	AUE_NULL	STD	{ int linux_timer_settime(void); }
 261	AUE_NULL	STD	{ int linux_timer_gettime(void); }
 262	AUE_NULL	STD	{ int linux_timer_getoverrun(void); }
 263	AUE_NULL	STD	{ int linux_timer_delete(void); }
-264	AUE_CLOCK_SETTIME	STD	{ int linux_clock_settime(void); }
-265	AUE_NULL	STD	{ int linux_clock_gettime(void); }
-266	AUE_NULL	STD	{ int linux_clock_getres(void); }
-267	AUE_NULL	STD	{ int linux_clock_nanosleep(void); }
+264	AUE_CLOCK_SETTIME	STD	{ int linux_clock_settime(clockid_t which, struct l_timespec *tp); }
+265	AUE_NULL	STD	{ int linux_clock_gettime(clockid_t which, struct l_timespec *tp); }
+266	AUE_NULL	STD	{ int linux_clock_getres(clockid_t which, struct l_timespec *tp); }
+267	AUE_NULL	STD	{ int linux_clock_nanosleep(clockid_t which, int flags, \
+					struct l_timespec *rqtp, struct l_timespec *rmtp); }
 268	AUE_NULL	STD	{ int linux_statfs64(void); }
 269	AUE_NULL	STD	{ int linux_fstatfs64(void); }
-270	AUE_NULL	STD	{ int linux_tgkill(void); }
+270	AUE_NULL	STD	{ int linux_tgkill(int tgid, int pid, int sig); }
 271	AUE_NULL	STD	{ int linux_utimes(void); }
 272	AUE_NULL	STD	{ int linux_fadvise64_64(void); }
 273	AUE_NULL	UNIMPL
--- /dev/null	Mon Aug 14 18:44:00 2006
+++ compat/linux/linux_emul.c	Mon Aug 14 18:46:20 2006
@@ -0,0 +1,297 @@
+/*-
+ * Copyright (c) 2006 Roman Divacky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer
+ *    in this position and unchanged.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include "opt_compat.h"
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/imgact.h>
+#include <sys/lock.h>
+#include <sys/malloc.h>
+#include <sys/mutex.h>
+#include <sys/sx.h>
+#include <sys/proc.h>
+#include <sys/syscallsubr.h>
+#include <sys/sysproto.h>
+#include <sys/unistd.h>
+
+#include <compat/linux/linux_emul.h>
+#include <compat/linux/linux_futex.h>
+
+#ifdef COMPAT_LINUX32
+#include <machine/../linux32/linux.h>
+#include <machine/../linux32/linux32_proto.h>
+#else
+#include <machine/../linux/linux.h>
+#include <machine/../linux/linux_proto.h>
+#endif
+
+struct sx emul_shared_lock;
+struct sx emul_lock;
+
+/* this returns locked reference to the emuldata entry (if found) */
+struct linux_emuldata *
+em_find(struct proc *p, int locked)
+{
+	struct linux_emuldata *em;
+
+	if (locked == EMUL_UNLOCKED)
+   		EMUL_LOCK(&emul_lock);
+
+	em = p->p_emuldata;	   	
+
+	if (em == NULL && locked == EMUL_UNLOCKED)
+	   	EMUL_UNLOCK(&emul_lock);
+
+	return (em);
+}
+
+int
+linux_proc_init(struct thread *td, pid_t child, int flags)
+{
+	struct linux_emuldata *em, *p_em;
+	struct proc *p;
+
+	if (child != 0) {
+	   	/* non-exec call */
+   		MALLOC(em, struct linux_emuldata *, sizeof *em, M_LINUX, M_WAITOK | M_ZERO);
+		em->pid = child;
+		if (flags & CLONE_VM) {
+		   	/* handled later in the code */
+		} else {
+		   	struct linux_emuldata_shared *s;
+
+   			MALLOC(s, struct linux_emuldata_shared *, sizeof *s, M_LINUX, M_WAITOK | M_ZERO);
+			em->shared = s;
+			s->refs = 1;
+			s->group_pid = child;
+
+			LIST_INIT(&s->threads);
+		}
+		p = pfind(child);
+		if (p == NULL)
+		   	panic("process not found in proc_init\n");
+		p->p_emuldata = em;
+		PROC_UNLOCK(p);
+	} else {
+		/* lookup the old one */
+		em = em_find(td->td_proc, EMUL_UNLOCKED);
+		KASSERT(em != NULL, ("proc_init: emuldata not found in exec case.\n"));
+	}
+
+	em->child_clear_tid = NULL;
+	em->child_set_tid = NULL;
+
+	/* allocate the shared struct only in clone()/fork cases 
+	 * in the case of clone() td = calling proc and child = pid of 
+	 * the newly created proc
+	 */
+	if (child != 0) {
+   	   	if (flags & CLONE_VM) {
+   		   	/* lookup the parent */
+		   	p_em = em_find(td->td_proc, EMUL_LOCKED);
+			KASSERT(p_em != NULL, ("proc_init: parent emuldata not found for CLONE_VM\n"));
+			em->shared = p_em->shared;
+			em->shared->refs++;
+		} else {
+		   	/* handled earlier to avoid malloc(M_WAITOK) with rwlock held */
+		}
+	}
+
+
+	if (child != 0) {
+	   	EMUL_SHARED_WLOCK(&emul_shared_lock);
+   	   	LIST_INSERT_HEAD(&em->shared->threads, em, threads);
+	   	EMUL_SHARED_WUNLOCK(&emul_shared_lock);
+
+		p = pfind(child);
+		PROC_UNLOCK(p);
+		/* we might have a sleeping linux_schedtail */
+		wakeup(&p->p_emuldata);
+	} else
+	   	EMUL_UNLOCK(&emul_lock);
+
+   	return (0);
+}
+
+void
+linux_proc_exit(void *arg __unused, struct proc *p)
+{
+   	struct linux_emuldata *em;
+	int error;
+	struct thread *td = FIRST_THREAD_IN_PROC(p);
+	int *child_clear_tid;
+
+	if (__predict_true(p->p_sysent != &elf_linux_sysvec))
+	   	return;
+
+	/* find the emuldata */
+	em = em_find(p, EMUL_UNLOCKED);
+
+	KASSERT(em != NULL, ("proc_exit: emuldata not found.\n"));
+
+	child_clear_tid = em->child_clear_tid;
+	
+	EMUL_UNLOCK(&emul_lock);
+
+	EMUL_SHARED_WLOCK(&emul_shared_lock);
+	LIST_REMOVE(em, threads);
+
+	PROC_LOCK(p);
+	p->p_emuldata = NULL;
+	PROC_UNLOCK(p);
+
+	em->shared->refs--;
+	if (em->shared->refs == 0)
+		FREE(em->shared, M_LINUX);
+	EMUL_SHARED_WUNLOCK(&emul_shared_lock);
+
+	if (child_clear_tid != NULL) {
+	   	struct linux_sys_futex_args cup;
+		int null = 0;
+
+		error = copyout(&null, child_clear_tid, sizeof(null));
+		if (error)
+		   	return;
+
+		/* futexes stuff */
+		cup.uaddr = child_clear_tid;
+		cup.op = LINUX_FUTEX_WAKE;
+		cup.val = 0x7fffffff; /* Awake everyone */
+		cup.timeout = NULL;
+		cup.uaddr2 = NULL;
+		cup.val3 = 0;
+		error = linux_sys_futex(FIRST_THREAD_IN_PROC(p), &cup);
+		/* this cannot happen at the moment and if this happens
+		 * it probably mean there is a userspace bug
+		*/
+		if (error)
+		   	printf(LMSG("futex stuff in proc_exit failed.\n"));
+	}
+
+	/* clean the stuff up */
+	FREE(em, M_LINUX);
+}
+
+/* This is used in a case of transition from FreeBSD binary execing to linux binary
+ * in this case we create linux emuldata proc entry with the pid of the currently running
+ * process.
+ */
+void linux_proc_exec(void *arg __unused, struct proc *p, struct image_params *imgp)
+{
+   	if (__predict_false(imgp->sysent == &elf_linux_sysvec 
+		 && p->p_sysent != &elf_linux_sysvec))
+	   	linux_proc_init(FIRST_THREAD_IN_PROC(p), p->p_pid, 0);
+	if (__predict_false(imgp->sysent != &elf_linux_sysvec
+		 && p->p_sysent == &elf_linux_sysvec)) {
+	   	struct linux_emuldata *em;
+
+		em = em_find(p, EMUL_UNLOCKED);
+
+		KASSERT(em != NULL, ("proc_exec: emuldata not found.\n"));
+		
+		EMUL_UNLOCK(&emul_lock);
+
+		EMUL_SHARED_WLOCK(&emul_shared_lock);
+		LIST_REMOVE(em, threads);
+
+		PROC_LOCK(p);
+		p->p_emuldata = NULL;
+		PROC_UNLOCK(p);
+
+		em->shared->refs--;
+		if (em->shared->refs == 0)
+		   	FREE(em->shared, M_LINUX);
+		EMUL_SHARED_WUNLOCK(&emul_shared_lock);
+
+		FREE(em, M_LINUX);
+	}
+}
+
+extern int hz;		/* in subr_param.c */
+
+void
+linux_schedtail(void *arg __unused, struct proc *p)
+{
+	struct linux_emuldata *em;
+	int error = 0;
+#ifdef	DEBUG
+	struct thread *td = FIRST_THREAD_IN_PROC(p);
+#endif
+	int *child_set_tid;
+
+	if (p->p_sysent != &elf_linux_sysvec)
+	   	return;
+
+retry:	
+	/* find the emuldata */
+	em = em_find(p, EMUL_UNLOCKED);
+
+	if (em == NULL) {
+	   	/* We might have been called before proc_init for this process so
+		 * tsleep and be woken up by it. We use p->p_emuldata for this
+		 */
+
+	   	error = tsleep(&p->p_emuldata, PLOCK, "linux_schedtail", hz);
+		if (error == 0)
+		   	goto retry;
+	   	panic("no emuldata found for userreting process.\n");
+	}
+	child_set_tid = em->child_set_tid;
+	EMUL_UNLOCK(&emul_lock);
+
+	if (child_set_tid != NULL)
+	   	error = copyout(&p->p_pid, (int *) child_set_tid, sizeof(p->p_pid));
+
+	return;
+}
+
+int
+linux_set_tid_address(struct thread *td, struct linux_set_tid_address_args *args)
+{
+   	struct linux_emuldata *em;
+
+#ifdef DEBUG
+	if (ldebug(set_tid_address))
+		printf(ARGS(set_tid_address, "%p"), args->tidptr);
+#endif
+
+	 /* find the emuldata */
+	em = em_find(td->td_proc, EMUL_UNLOCKED);
+
+	KASSERT(em != NULL, ("set_tid_address: emuldata not found.\n"));
+
+	em->child_clear_tid = args->tidptr;
+	td->td_retval[0] = td->td_proc->p_pid;
+
+	EMUL_UNLOCK(&emul_lock);
+	return 0;
+}
--- /dev/null	Mon Aug 14 18:44:00 2006
+++ compat/linux/linux_emul.h	Mon Aug 14 18:46:21 2006
@@ -0,0 +1,74 @@
+/*-
+ * Copyright (c) 2006 Roman Divacky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer
+ *    in this position and unchanged.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $FreeBSD$
+ */
+
+#ifndef _LINUX_EMUL_H_
+#define _LINUX_EMUL_H_
+
+struct linux_emuldata_shared {
+   	int	refs;
+	pid_t	group_pid;
+
+	LIST_HEAD(, linux_emuldata) threads;	/* head of list of linux threads */
+};
+
+/* modeled after similar structure in NetBSD 
+ * this will be extended as we need more functionality
+ */
+struct linux_emuldata {
+   	pid_t	pid;
+
+	int *child_set_tid;     /* in clone(): Child's TID to set on clone */
+	int *child_clear_tid;   /* in clone(): Child's TID to clear on exit */
+
+	struct linux_emuldata_shared *shared;
+
+	LIST_ENTRY(linux_emuldata) threads;	/* list of linux threads */
+};
+
+struct linux_emuldata *em_find(struct proc *, int locked);
+
+#define EMUL_LOCK(l)	sx_xlock(l)
+#define EMUL_UNLOCK(l)	sx_xunlock(l)
+
+#define EMUL_SHARED_RLOCK(l) sx_slock(l)
+#define EMUL_SHARED_RUNLOCK(l) sx_sunlock(l)
+#define EMUL_SHARED_WLOCK(l) sx_xlock(l)
+#define EMUL_SHARED_WUNLOCK(l) sx_xunlock(l)
+
+/* for em_find use */
+#define EMUL_LOCKED		1
+#define EMUL_UNLOCKED		0
+
+int linux_proc_init(struct thread *, pid_t, int);
+void linux_proc_exit(void *, struct proc *);
+void linux_schedtail(void *, struct proc *);
+void linux_proc_exec(void *, struct proc *, struct image_params *);
+
+#endif /* !_LINUX_EMUL_H_ */
